/***************************************************************************
 * RCS INFORMATION:
 *
 *	$RCSfile: detailed_graphics.c,v $
 *	$Author: jyelon $	$Locker:  $		$State: Exp $
 *	$Revision: 1.2 $	$Date: 1995/02/24 23:23:03 $
 *
 ***************************************************************************
 * DESCRIPTION:
 *
 ***************************************************************************
 * REVISION HISTORY:
 *
 * $Log: detailed_graphics.c,v $
 * Revision 1.2  1995/02/24 23:23:03  jyelon
 * *** empty log message ***
 *
 ***************************************************************************/
static char ident[] = "@(#)$Header: /expand1/cvsroot/projections/sources/graphics/detailed_graphics.c,v 1.2 1995/02/24 23:23:03 jyelon Exp $";
#include "head.h"
#include "common.h"
#include "graphics.h"
#include "detailed.h" 

extern graphics_data *current_data;
extern char *determine_title();

/*****************************************************************/
/** Draw the scales for this graph.				**/
/*****************************************************************/
draw_detailed_scale(data)
graphics_data *data;
{
	int i, j;
	int pixels;
	int ydispl;
	char str[100];
	int xpeno, ypeno;
	Font font1, font2;
	int xoffset, yoffset;
	int busy_xoffset, busy_length;
	YAXISTITLE *ytitle1, *ytitle2;
	XFontStruct *font_struct1, *font_struct2;

	int type = data->type;

	int xorigin 	= 0;
	int xstep = data->xstep;
	int xscale = data->xscale;
	int xheight = data->xheight;
	int xdivisons = data->xdivisons;

	int ystep = data->ystep;
	int yscale = data->yscale;
	int yheight = data->yheight;
	int ydivisons = data->ydivisons;
	int yorigin 	= DISPLAY_YDISPLACEMENT;

	int busy_step = data->busy_ystep;
	int busy_scale = data->busy_yscale;
	int busy_divisons = data->busy_ydivisons;

	int start_xdivs = data->start_xdivs;
	int finish_xdivs = data->finish_xdivs;

	int min = data->min;
	int max = data->max;
	int busy_min = data->busy_min;
	int bust_max = data->busy_max;

	char *xtitle = data->xtitle;


	GC gc1 = data->gc1;
	GC gc2 = data->gc2;
	GC gc3 = data->gc3;

	Widget w1 = data->canvas1;
	Widget w2 = data->canvas2;
	Widget w3 = data->canvas3;

	
	/*********************************************************/
	/** Get the fonts for the axis divisions.		**/
	/*********************************************************/
	font1 = XLoadFont(XtDisplay(w1), "8x13");
	font_struct1 = XQueryFont(XtDisplay(w1), font1);

	/*********************************************************/
	/** Get the fonts for the axis titles.			**/
	/*********************************************************/
	font2 = XLoadFont(XtDisplay(w1),  "6x12");
	font_struct2 = XQueryFont(XtDisplay(w1), font2);


	/*********************************************************/
	/** First figure out the origin and offset. Reverse y	**/
	/** coordinates because otherwise we get an inverted 	**/
	/** coordinate system.					**/
	/*********************************************************/
	data->xoffset = xoffset = xorigin;
	data->yoffset = yoffset = yheight - yorigin;
	busy_xoffset = 0;

	/*********************************************************/
        /** Draw the y-axis, its divisons, and the labels.      **/
	/*********************************************************/
	xoffset = SIDES;
	/*
	draw_line(w1, gc1, 
			xoffset, yoffset, 
			xoffset, yoffset - (ydivisons/ystep+1)*yscale); 
	*/
    for (j=min; j<=max+ystep; j+=ystep)
    {
         int k;

         k = j - min;
         draw_line(w1, gc1, xoffset - XSCALE/4, yoffset - (k*yscale)/ystep,
                        xoffset + XSCALE/4, yoffset - (k*yscale)/ystep);
         sprintf(str, "%d", j);
         pixels = XTextWidth(font_struct1, str, strlen(str));
         xpeno = xoffset - pixels - XTextWidth(font_struct1, "0",
                        strlen("0"));
         ypeno = yoffset - (k*yscale)/ystep;
         draw_string(w1, gc1, xpeno, ypeno, str, strlen(str), "8x13");
    }

        /*********************************************************/
        /** Now write the title for the message-axis.           **/
        /*********************************************************/
	ytitle1 = (YAXISTITLE *) malloc(sizeof(YAXISTITLE));
	ytitle1->count_y_title = 1;
	ytitle1->y_title[0] = (char *) malloc(strlen("MESSAGES") + 1);
	strcpy(ytitle1->y_title[0], "MESSAGES");

        ydispl = yoffset -
                ((yscale*ydivisons)/ystep +
                        (ytitle1->count_y_title*
                        (font_struct2->ascent + YSEPARATION)))/2;

        for (i=0; i<ytitle1->count_y_title; i++)
        {
                pixels = XTextWidth(font_struct2, ytitle1->y_title[i],
                                        strlen(ytitle1->y_title[i]));
                ypeno = ydispl + i*(font_struct2->ascent + YSEPARATION);
                xpeno = (xoffset - XDISPLACEMENT + 10);
                draw_string(w1, gc1, xpeno, ypeno, ytitle1->y_title[i],
                        strlen(ytitle1->y_title[i]),  "6x12");
        }



	/*********************************************************/
	/** Draw the x-axis, its divisons, and the labels.	**/
	/*********************************************************/
	xoffset = data->xoffset;
	draw_line(w2, gc2, 	
			xoffset, yoffset, 
			xoffset + (xdivisons*xscale)/xstep, yoffset);
	sprintf(str, "%d", 0);
	pixels = XTextWidth(font_struct1, str, strlen(str));
	ypeno = yoffset + 2*pixels;
	for (i=start_xdivs; i<=finish_xdivs; i+=xstep)
	{
		int k;
		int xpe;

		k = i - start_xdivs;
		xpe = xoffset + (k*xscale)/xstep; 
		draw_line(w2, gc2, 
			xpe, yoffset - YSCALE/4,
			xpe, yoffset + YSCALE/4);
		sprintf(str, "%d", i);
		draw_string(w2, gc2, xpe+3, yoffset + YSCALE, str,
				strlen(str), "8x13");
	}

        /*********************************************************/
        /** write the title for the X-axis.               	**/
        /*********************************************************/
        pixels = XTextWidth(font_struct2, xtitle, strlen(xtitle));
        xpeno = ((xscale*(xdivisons-1))/xstep - pixels)/2; 
        ypeno = (yoffset + 2*YSCALE);
        draw_string(w2, gc2, xpeno, ypeno, xtitle, strlen(xtitle), "6x12");


	/*********************************************************/
	/** Draw the busy-axis.					**/
	/*********************************************************/
       	busy_length = 0;
        for (j=busy_min; j<data->busy_max+busy_step; j+=busy_step)
        {
                int k;

                k = j-busy_min;
                draw_line(w3, gc3,
                        busy_xoffset - XSCALE/4,
                        yoffset - (k*busy_scale)/busy_step,
                        busy_xoffset + XSCALE/4,
                        yoffset - (k*busy_scale)/busy_step);
                sprintf(str, "%d", j);

		xpeno = busy_xoffset + 
				XTextWidth(font_struct1, "00", strlen("00"));
		ypeno = yoffset - (k*busy_scale)/busy_step; 
		draw_string(w3, gc3, xpeno, ypeno, str, strlen(str), "8x13");
		busy_length += busy_scale;
	}

	busy_length -= busy_scale;
	/*
	draw_line(w3, gc3, 
			busy_xoffset, yoffset, 
			busy_xoffset, yoffset - busy_length);
	*/


	/*********************************************************/
	/** Now write the title for the busy-axis.		**/
	/*********************************************************/
	ytitle2 = (YAXISTITLE *) malloc(sizeof(YAXISTITLE));
	ytitle2->count_y_title = 2; 
	ytitle2->y_title[0] = (char *) malloc(strlen("PERCENT") + 1);
	strcpy(ytitle2->y_title[0], "PERCENT");
	ytitle2->y_title[1] = (char *) malloc(strlen("BUSY") + 1);
	strcpy(ytitle2->y_title[1], "BUSY");
	ydispl = yoffset - 
		((yscale*ydivisons)/ystep + 
			(ytitle2->count_y_title*
			(font_struct2->ascent + YSEPARATION)))/2;

	for (i=0; i<ytitle2->count_y_title; i++)
	{
		pixels = XTextWidth(font_struct2, ytitle2->y_title[i],
					strlen(ytitle2->y_title[i]));
		ypeno = ydispl + i*(font_struct2->ascent + YSEPARATION);
		xpeno = xoffset + 50; 
		draw_string(w3, gc3, xpeno, ypeno, ytitle2->y_title[i], 
			strlen(ytitle2->y_title[i]),  "6x12");
	}

}





/*****************************************************************/
/** This function is called to draw the graph. The last parameter**/
/** is necessary to know which type of graph it is -- scrolled/	**/
/** stage-by-stage.						**/
/*****************************************************************/
draw_detailed_graph(data, is_ep, is_creation, table, ydivisons, min, yscale, ystep)
graphics_data *data;
int is_ep, is_creation, table, ydivisons, min, yscale, ystep;
{
	int i;
	int temp;
	int idash;
	XPoint *points;
	int current_point = 0;

    int type = data->type;
	int current = data->current;

    int xstep = data->xstep;
    int xscale = data->xscale;
    int xheight = data->xheight;
    int xoffset = data->xoffset;
    int xdivisons = data->xdivisons;

    int yoffset = data->yoffset;
    int yheight = data->yheight;

    int start_xdivs = data->start_xdivs;
    int finish_xdivs = data->finish_xdivs;

    int begin_pe = data->begin_pe;
    int end_pe = data->end_pe;
    int begin_stages = data->begin_stages;
    int end_stages = data->end_stages;

    GC gc = data->gc2;
    Widget w = data->canvas2;

	
	set_color_and_line_type(w, gc,  is_creation, table);

	points = (XPoint *) malloc(sizeof(XPoint)*xdivisons);
	switch (type) {

	case CONSTANT_PE:
            for (i=start_xdivs; i<=finish_xdivs; i++)
            {
				idash = i - start_xdivs;
				if (!is_ep)
					temp = display_table[table][current][i];
				else
				{
					if (is_creation)
						temp = ep_c_display_table[table][current][i];
					else
						temp = ep_p_display_table[table][current][i];
				}
				points[current_point].x = 
					xoffset + (idash*xscale)/xstep;
				points[current_point].y = 
					yoffset - (yscale* (temp - min))/ystep;
				current_point++;
			}
		break;

	case TOTAL_STAGE:
            for (i=start_xdivs; i<=finish_xdivs; i++)
            {
                int j, temp;

                temp = 0;
                idash = i - start_xdivs;
 				for (j=begin_stages; j<=end_stages; j++)
				if (!is_ep)
                    temp += display_table[table][i][j];
				else
				{
					if (is_creation)
                    	temp += ep_c_display_table[table][i][j];
					else
                    	temp += ep_p_display_table[table][i][j];
				}
				if (!is_ep && (table == IDLE_TIME || table == OVERHEAD_TIME))
					temp /= (end_stages - begin_stages +1 );
                points[current_point].x =
                                xoffset + (idash*xscale)/xstep;
                points[current_point].y =
                                yoffset - (yscale* (temp - min))/ystep;
                current_point++;
            }
            break;


	case CONSTANT_STAGE:
            for (i=start_xdivs; i<=finish_xdivs; i++)
            {
				idash = i - start_xdivs;
				if (!is_ep)
					temp = display_table[table][i][current];
				else
				{
					if (is_creation)
						temp = ep_c_display_table[table][i][current];
					else
						temp = ep_p_display_table[table][i][current];
				}
				points[current_point].x = 
					xoffset + (idash*xscale)/xstep;
				points[current_point].y = 
					yoffset - (yscale* (temp - min))/ystep;
				current_point++;
			}
			break;

	case TOTAL_PE:
            for (i=start_xdivs; i<=finish_xdivs; i++)
            {
                int j, temp;

                temp = 0;
                idash = i - start_xdivs;
                for (j=begin_pe; j<=end_pe; j++)
				if (!is_ep)
                    temp += display_table[table][j][i];
				else
				{
					if (is_creation)
                    	temp += ep_c_display_table[table][j][i];
					else
                    	temp += ep_p_display_table[table][j][i];
				}
				if (!is_ep && (table == IDLE_TIME || table == OVERHEAD_TIME))
					temp /= (end_pe - begin_pe + 1);
                points[current_point].x =
                    xoffset + (idash*xscale)/xstep;
                points[current_point].y =
                    yoffset - (yscale* (temp - min))/ystep;
                current_point++;
            }
            break;


	}


	for (i=0; i<current_point-1; i++)
        if (points[i].y != yoffset || points[i+1].y != yoffset)
			draw_line(w, gc, points[i].x, points[i].y, 
					points[i+1].x, points[i+1].y);
}

/*****************************************************************/
/** This procedure is called to draw the bar diagram. It first	**/
/** calls the function, draw_scale, to draw the scales, and then**/
/** it calls the functions draw_bars to draw the bars. 		**/
/*****************************************************************/
draw_display(data, type)
graphics_data *data;
int type;
{
	int i;
	int busy_step; 
	int busy_scale;


	XClearArea(XtDisplay(data->canvas1), XtWindow(data->canvas1),
			0, 0, 0, 0, FALSE);
	XClearArea(XtDisplay(data->canvas2), XtWindow(data->canvas2),
			0, 0, 0, 0, FALSE);
	XClearArea(XtDisplay(data->canvas3), XtWindow(data->canvas3),
			0, 0, 0, 0, FALSE);

	data->type = type;
    set_detailed_parameters(data, data->type,
                       	data->begin_pe, data->end_pe,
                       	data->begin_stages, data->end_stages);
	draw_detailed_scale(data);
	draw_legend_information(data);

	for (i=0; i<NUMBER_DISPLAYS; i++)
		if (data->chosen[i])
		{
			if (i==IDLE_TIME || i==OVERHEAD_TIME)
    				draw_detailed_graph(data, FALSE, FALSE, i,
                                        data->busy_ydivisons, data->busy_min,
                                        data->busy_yscale, data->busy_ystep);
                                        
			else
                                draw_detailed_graph(data, FALSE, FALSE, i,
                                        data->ydivisons, data->min,
                                        data->yscale, data->ystep);
		}

    for (i=0; i<number_entries; i++)
	{
        if (data->ep_c_chosen[i])
            draw_detailed_graph(data, TRUE, TRUE, i, data->ydivisons, data->min,
                                        data->yscale, data->ystep);
        if (data->ep_p_chosen[i])
            draw_detailed_graph(data, TRUE, FALSE, i, data->ydivisons,
									data->min, data->yscale, data->ystep); 
	}

   	XSetLineAttributes(XtDisplay(data->canvas1), data->gc1, 1,
                 LineSolid, CapButt, JoinMiter);
   	XSetLineAttributes(XtDisplay(data->canvas2), data->gc2, 1,
                 LineSolid, CapButt, JoinMiter);
    XSetLineAttributes(XtDisplay(data->canvas3), data->gc3, 1,
                 LineSolid, CapButt, JoinMiter);

	XSetForeground(XtDisplay(data->canvas2), data->gc2,
					data->foreground);
}
